//---------------------------------------------------------------------------

#ifndef FormComPortH
#define FormComPortH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
//---------------------------------------------------------------------------
class TfrmComPort : public TForm
{
__published:	// IDE-managed Components
	TLabel *lblPort;
	TComboBox *cbSerialPorts;
	TLabel *lblBaudrate;
	TEdit *edSerialPortBaudrate;
	TButton *btnPortOpen;
	TButton *btnPortClose;
	TButton *btnRefreshList;
	void __fastcall FormShow(TObject *Sender);
	void __fastcall btnPortOpenClick(TObject *Sender);
	void __fastcall cbSerialPortsChange(TObject *Sender);
	void __fastcall edSerialPortBaudrateChange(TObject *Sender);
	void __fastcall btnPortCloseClick(TObject *Sender);
	void __fastcall btnRefreshListClick(TObject *Sender);
private:	// User declarations
	int PortOpen(AnsiString name, unsigned int baudrate);
	void PortClose(void);
	void RefreshPortList(void);
public:		// User declarations
	__fastcall TfrmComPort(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TfrmComPort *frmComPort;
//---------------------------------------------------------------------------
#endif
