//---------------------------------------------------------------------------

#ifndef FormUartMtTestH
#define FormUartMtTestH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>

//---------------------------------------------------------------------------

#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Menus.hpp>


#include "mersenne_twister.h"

class TfrmUartMtTest : public TForm
{
__published:	// IDE-managed Components
	TButton *btnStartTest;
	TButton *btnStopTest;
	TTimer *tmrTest;
	TLabel *lblTxDataCount;
	TEdit *edTxDataCount;
	TLabel *lblRxDataCount;
	TEdit *edRxDataCount;
	TLabel *lblMismatchCount;
	TEdit *edMismatchCount;
	TLabel *Label1;
	TEdit *edTotalTxDataCount;
	TButton *btnSingleStepTest;
	TLabel *lblStepBytes;
	TEdit *edDataCountMin;
	TEdit *edDataCountMax;
	TLabel *lblTo;
	TButton *btnResetStats;
	TButton *btnResetTest;
	TLabel *lblInterval;
	TEdit *edIntervalMin;
	TLabel *Label2;
	TEdit *edIntervalMax;
	TLabel *lblMs;
	void __fastcall FormShow(TObject *Sender);
	void __fastcall btnStartTestClick(TObject *Sender);
	void __fastcall btnStopTestClick(TObject *Sender);
	void __fastcall tmrTestTimer(TObject *Sender);
	void __fastcall btnSingleStepTestClick(TObject *Sender);
	void __fastcall btnResetStatsClick(TObject *Sender);
	void __fastcall btnResetTestClick(TObject *Sender);
	void __fastcall ParamsChange(TObject *Sender);
private:	// User declarations

	struct mt_rand mtTx;
	uint64_t mtTxCnt;
	uint32_t mtTxLastVal;

	struct mt_rand mtRx;
	uint64_t mtRxCnt;
	uint32_t mtRxLastVal;

	uint32_t mismatchCount;
	uint32_t totalTxCnt;

	struct mt_rand mtSize;

	void HandleTest(void);
	void UpdateTxRxDisplay(void);
	void Reset(void);			
	
public:		// User declarations
	__fastcall TfrmUartMtTest(TComponent* Owner);
	__fastcall ~TfrmUartMtTest();
};
//---------------------------------------------------------------------------
extern PACKAGE TfrmUartMtTest *frmUartMtTest;
//---------------------------------------------------------------------------
#endif
